# -*- coding: utf-8 -*-

from pympi import Eaf
from glob import glob
import codecs
import re

rem_chars = unicode('[「」？.@]+|\\[.*\\]|&=\\S*', 'utf-8')

# 0. Load a dictionary
with codecs.open('dictionary.txt', 'r', 'utf8') as dict_in:
    BCCWJ = {}
    for line in dict_in:
        line = line.strip()
        key, value = line.split('\t')
        BCCWJ[key] = value

# 1. Load all files

for filepath in glob('0*.eaf'):
    print filepath
    a = Eaf(filepath)
# 1a. create new tiers
    for tier in a.get_tier_names():
        a.add_tier('{}_word'.format(tier))
        a.add_tier('{}_pos'.format(tier))

# 2. For every annotation in the tier we want children annotation which contain
# separate words
        for begin, end, value in a.get_annotation_data_for_tier(tier):
            value = re.sub(rem_chars, '', value, flags=re.UNICODE)
            value = value.split()
            if not value:
                continue
            length = (end - begin) / len(value)
            for i, word in enumerate(value):
                a.insert_annotation('{}_word'.format(tier), begin+i*length,
                                    begin+(i+1)*length, word)

# 3. For every word we wnat to enter a matching pos annotation

                a.insert_annotation('{}_pos'.format(tier), begin+i*length,
                                    begin+(i+1)*length, BCCWJ.get(word, '?'))

    filepath = filepath.split('/')
    filepath[-1] = 'x' + filepath[-1]
    a.to_file('/'.join(filepath))
